/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM flockIMediaUploadWebService.idl
 */

#ifndef __gen_flockIMediaUploadWebService_h__
#define __gen_flockIMediaUploadWebService_h__


#ifndef __gen_flockIListener_h__
#include "flockIListener.h"
#endif

#ifndef __gen_flockIMediaWebService_h__
#include "flockIMediaWebService.h"
#endif

#ifndef __gen_flockIPhotoUpload_h__
#include "flockIPhotoUpload.h"
#endif

#ifndef __gen_flockIWebService_h__
#include "flockIWebService.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    flockIMediaUploadWebService */
#define FLOCKIMEDIAUPLOADWEBSERVICE_IID_STR "73596a3d-1234-4d97-8fd8-a46868fafa42"

#define FLOCKIMEDIAUPLOADWEBSERVICE_IID \
  {0x73596a3d, 0x1234, 0x4d97, \
    { 0x8f, 0xd8, 0xa4, 0x68, 0x68, 0xfa, 0xfa, 0x42 }}

/**
 * Represents a web service that supports uploading of rich media (eg. photos,
 * video).  Generally, a service that implements flockIMediaUplaodWebService
 * will also implement flockIMediaWebService.
 *
 * More documentation here:
 * http://developer.flock.com/wiki/Accounts_Management
 *
 * @see flockIMediaWebService
 * @see flockIMediaAccount
 * @see flockIMediaUploadAccount
 */
class NS_NO_VTABLE NS_SCRIPTABLE flockIMediaUploadWebService : public flockILoginWebService {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIMEDIAUPLOADWEBSERVICE_IID)

  /**
   * Query the server to get information about the current user's account.
   *
   * @param aFlockListener (in) the listener used to pass the result.
   *                  onSuccess(result, topic) will be return,
   *                  only result holding a relevant value.
   *
   *                  result is a nsIPropertyBag2 holding the following values:
   *                  @li boolean isPremium;
   *                  @li string maxFileSize;
   *                  @li string maxSpace;
   *                  @li string usageUnits;
   *                  @li string usedSpace;
   *                  @li string username;
   */
  /* void getAccountStatus (in flockIListener aFlockListener); */
  NS_SCRIPTABLE NS_IMETHOD GetAccountStatus(flockIListener *aFlockListener) = 0;

  /**
   * Gets albums that are only upload endpoints.
   *
   * @param aFlockListener (in) Specifies a callback listener
   * @param aUsername (in) Specifies a username to operate the search as
   */
  /* void getAlbumsForUpload (in flockIListener aFlockListener, in AString aUsername); */
  NS_SCRIPTABLE NS_IMETHOD GetAlbumsForUpload(flockIListener *aFlockListener, const nsAString & aUsername) = 0;

  /* void createAlbum (in flockIListener aFlockListener, in AString aAccountId, in AString aAlbumName); */
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(flockIListener *aFlockListener, const nsAString & aAccountId, const nsAString & aAlbumName) = 0;

  /**
   * Return true if the service supports aFeature, false otherwise.
   * Available features:
   *    fileName
   *    title
   *    description
   *    privacy
   *    tags
   *    notes (means notes associated to a specific point in the image)
   */
  /* boolean supportsFeature (in AString aFeature); */
  NS_SCRIPTABLE NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) = 0;

  /**
   * Upload one photo to the service
   * @param aFlockListener (in) the listener used to pass the result.
   *    onSuccess(result, topic) will be called, with result being
   *    a flockIMediaItem representing the photo on the service.
   * @param aUpload (in) the metadata for the photo
   * @param aFilename (in) the filename on the local hard disk
   *    (usually a copy of the original file in the user's profile dir)
   */
  /* void upload (in flockIPhotoUploadAPIListener aUploadListener, in flockIPhotoUpload aUpload, in AString aFilename); */
  NS_SCRIPTABLE NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aUploadListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIMediaUploadWebService, FLOCKIMEDIAUPLOADWEBSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIMEDIAUPLOADWEBSERVICE \
  NS_SCRIPTABLE NS_IMETHOD GetAccountStatus(flockIListener *aFlockListener); \
  NS_SCRIPTABLE NS_IMETHOD GetAlbumsForUpload(flockIListener *aFlockListener, const nsAString & aUsername); \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(flockIListener *aFlockListener, const nsAString & aAccountId, const nsAString & aAlbumName); \
  NS_SCRIPTABLE NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval); \
  NS_SCRIPTABLE NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aUploadListener, flockIPhotoUpload *aUpload, const nsAString & aFilename); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIMEDIAUPLOADWEBSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetAccountStatus(flockIListener *aFlockListener) { return _to GetAccountStatus(aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetAlbumsForUpload(flockIListener *aFlockListener, const nsAString & aUsername) { return _to GetAlbumsForUpload(aFlockListener, aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(flockIListener *aFlockListener, const nsAString & aAccountId, const nsAString & aAlbumName) { return _to CreateAlbum(aFlockListener, aAccountId, aAlbumName); } \
  NS_SCRIPTABLE NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) { return _to SupportsFeature(aFeature, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aUploadListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) { return _to Upload(aUploadListener, aUpload, aFilename); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIMEDIAUPLOADWEBSERVICE(_to) \
  NS_SCRIPTABLE NS_IMETHOD GetAccountStatus(flockIListener *aFlockListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccountStatus(aFlockListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetAlbumsForUpload(flockIListener *aFlockListener, const nsAString & aUsername) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAlbumsForUpload(aFlockListener, aUsername); } \
  NS_SCRIPTABLE NS_IMETHOD CreateAlbum(flockIListener *aFlockListener, const nsAString & aAccountId, const nsAString & aAlbumName) { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateAlbum(aFlockListener, aAccountId, aAlbumName); } \
  NS_SCRIPTABLE NS_IMETHOD SupportsFeature(const nsAString & aFeature, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->SupportsFeature(aFeature, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD Upload(flockIPhotoUploadAPIListener *aUploadListener, flockIPhotoUpload *aUpload, const nsAString & aFilename) { return !_to ? NS_ERROR_NULL_POINTER : _to->Upload(aUploadListener, aUpload, aFilename); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIMediaUploadWebService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIMEDIAUPLOADWEBSERVICE

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIMediaUploadWebService)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* void getAccountStatus (in flockIListener aFlockListener); */
NS_IMETHODIMP _MYCLASS_::GetAccountStatus(flockIListener *aFlockListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getAlbumsForUpload (in flockIListener aFlockListener, in AString aUsername); */
NS_IMETHODIMP _MYCLASS_::GetAlbumsForUpload(flockIListener *aFlockListener, const nsAString & aUsername)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void createAlbum (in flockIListener aFlockListener, in AString aAccountId, in AString aAlbumName); */
NS_IMETHODIMP _MYCLASS_::CreateAlbum(flockIListener *aFlockListener, const nsAString & aAccountId, const nsAString & aAlbumName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean supportsFeature (in AString aFeature); */
NS_IMETHODIMP _MYCLASS_::SupportsFeature(const nsAString & aFeature, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void upload (in flockIPhotoUploadAPIListener aUploadListener, in flockIPhotoUpload aUpload, in AString aFilename); */
NS_IMETHODIMP _MYCLASS_::Upload(flockIPhotoUploadAPIListener *aUploadListener, flockIPhotoUpload *aUpload, const nsAString & aFilename)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    flockIMediaUploadAccount */
#define FLOCKIMEDIAUPLOADACCOUNT_IID_STR "fe173aae-8f49-4bd4-beda-41ec1e09b232"

#define FLOCKIMEDIAUPLOADACCOUNT_IID \
  {0xfe173aae, 0x8f49, 0x4bd4, \
    { 0xbe, 0xda, 0x41, 0xec, 0x1e, 0x09, 0xb2, 0x32 }}

/**
 * Represents a web service account that supports uploading of rich media (eg.
 * photos, video).
 *
 * @see flockIMediaWebService
 * @see flockIMediaAccount
 */
class NS_NO_VTABLE NS_SCRIPTABLE flockIMediaUploadAccount : public flockIMediaAccount {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(FLOCKIMEDIAUPLOADACCOUNT_IID)

};

  NS_DEFINE_STATIC_IID_ACCESSOR(flockIMediaUploadAccount, FLOCKIMEDIAUPLOADACCOUNT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_FLOCKIMEDIAUPLOADACCOUNT \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_FLOCKIMEDIAUPLOADACCOUNT(_to) \
  /* no methods! */

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_FLOCKIMEDIAUPLOADACCOUNT(_to) \
  /* no methods! */

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public flockIMediaUploadAccount
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_FLOCKIMEDIAUPLOADACCOUNT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, flockIMediaUploadAccount)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* End of implementation class template. */
#endif


#endif /* __gen_flockIMediaUploadWebService_h__ */
